module Abs(Abs,(\\),unAbs) where 

import AbsM
import Atom
import Nominal

data Abs t                       = Abs (Atom) t

(\\)                             :: Nominal t => Atom -> t -> Abs t
a \\ t                           =  Abs a t

unAbs                            :: Nominal t => Abs t -> AM (Atom,t)
unAbs (Abs a t)                  = rename a >>= \a' -> 
				   return (a',swap a a' t)

instance (Eq t,Nominal t) => Eq (Abs t) where
    (Abs a1 t1) == (Abs a2 t2)   =  (a1 == a2 && t1 == t2) 
				    || (a1 `fresh` t2 && t1 == swap a1 a2 t2)

instance (Show t) => Show (Abs t) where
    showsPrec i (Abs a t)        = showsPrec i a . 
				   showString " \\\\ " . 
				   showsPrec i t

instance Nominal t => Nominal (Abs t) where
    swap a b (Abs a1 t1)         = Abs (swap a b a1) (swap a b t1)
    fresh a (Abs b t)            = if a == b 
				   then True 
				   else fresh a t
    supp (Abs a t)               = filter (\b -> not(b == a)) (supp t)
