module Lam where

import AbsM
import Atom
import Nominal
import Abs

-- Nominal lambda calculus 

data Lam = Var Atom 
	 | App Lam Lam
	 | Lam (Abs Lam) deriving (Eq, Show)

instance Nominal Lam where
    swap a b (Var c) = Var (swap a b c)
    swap a b (App t1 t2) = App (swap a b t1) (swap a b t2)
    swap a b (Lam ab) = Lam (swap a b ab)
    fresh a (Var c) = fresh a c
    fresh a (App t1 t2) = fresh a t1 && fresh a t2
    fresh a (Lam ab) = fresh a ab
    supp (Var c) = supp c
    supp (App t1 t2) = supp t1 ++ supp t2
    supp (Lam ab) = supp ab

subst                            :: (Atom -> Maybe Lam) -> Lam -> AM Lam
subst s (Var c)                  =  case s c 
				    of {Just t -> return t;
					Nothing -> return (Var c)}
subst s (App t1 t2)              =  do t1' <- subst s t1;
				       t2' <- subst s t2;
				       return (App t1' t2')
subst s (Lam ab)                 =  do (a,t) <- unAbs ab;
				       t' <- subst s t;
				       return (Lam (a\\t'))

